// #######################################################################
// ### generator.cc                                                    ###
// ### Testdaten-Generator                                             ###
// ### von Thomas Dreibholz, Dreibholz@bigfoot.com                     ###
// #######################################################################


#include <stdio.h>
#include <stdlib.h>

char* nn[]={"Schmidt","Mller","Meier","Schulz","Dreibholz","Schmitz","Schulze",
            "Gates","Clinton","Cremers","Kniesel","Karpinski","Fellner","Becker",
            "Bundy","Bond","Schrder","Schrter","Huber","Hube","Baier","Gro",
            "Costanza","Bauer","Becker","Schneider","Maier","Mayer","Klein","Rambo",
            "Kohl","Adenauer","Reagan","Bush","Erhard","Martini","Hbel","Reichelt",
            "Schweizer","Schwarz","Stein","Steiner","Cauchy","Neumann","von Neumann",
            "Cray","Eickler","Kemper","Fischer","Fuchs","Schtte","Kortmann","Kpke",
            "Frehse","Klingenberg","Weddige","Gr","Krger","Hofer","Wolff","Wolf",
            "Rler","Frey","Klaas","Clausen","Klausen","Berg","Berger","Burger",
            "Hoffmann","Khler","Kster","Coester","Fries","Buerle","Swer","Suhrkamp",
            "Sauer","Busch","Bosch","Orec","Gr","Azizi","Beetz","Bergmann","Bode",
            "Hermes","Fox","Doelp","Liebegut","Steinhage","Spalka","Stiemerling",
            "Marikar","Lengauer","Dorgerloh","Guenzel","Grauert","Gray","Tanenbaum",
            "Miller","Smith","Jones","Newman","Washington","Picard","Kirk","Eckmiller",
            "Hormes","Gnther","Manthey","Wirtgen","Hussein","Wenzel","Altmann","Tlle"};
char* vn[]={"Albert","Bernhard","Gnter","Walter","Thomas","Klaus","Dieter",
            "Jrgen","Herbert","Armin","Pascal","Bill","Joachim","Alf","Ralf","Gnther",
            "Ernst","Klaus-Dieter","Dietmar","Peter","Rolf Dieter","Siegfried","Bertram",
            "Berthold","Alfred","Al","Bruno","James","Jefferson","Alfredo","Jrgen","Marek",
            "Mark","Mike","Thorsten","Rolf","Benedikt","Okan","John","Johann","Johannes","Jon",
            "Willi","Willy","Willibald","Gerhard","Ernst-Otto","Otto","Ernst Gnter","Ernesto",
            "Joe","Michael","Theodor","Theo","Sven","Markus","Lothar","Lars","Lukas","George",
            "Ronald","Tilmann","Christian","Harald","Linus","Tux","Saddam","Albrecht","Thor",
            "Zeus","Ulrich","Wilhelm","Wilfried","Werner","Kurt","Karl","Uwe","Wolfgang","Frank",
            "Heinz","Berthold","Damir","Kristof","Brunhilde","Peg","Bud","Kelly","Ike",
            "Gunther","Guntram","Maria","Anna","Hannelore","Helmut","Gerhard","Ludwig","Jens"};
char* uni[]={"Bonn","Kln","Hamburg","Mnchen","Frankfurt","Stuttgart","Karlsruhe","Paderborn",
             "Moskau","Novosibirsk","New York","Los Angeles","San Diego","San Francisco",
             "Nrnberg","Hannover","Berlin"};
int anz_nn = sizeof(nn) / 4;
int anz_vn = sizeof(vn) / 4; 
int anz_uni = sizeof(uni) / 4;

void main(int argc, char* argv[])
{
   if(argc < 4) {
      printf("Aufruf: %s [Anzahl Namen] [Anzahl Publikationen] [Max Instanzen/Publ.]\n",argv[0]);
      printf("Namen: %d * %d = %d\n",anz_vn,anz_nn,anz_vn*anz_nn);
      exit(1);
   }   
   int anz_namen = atol(argv[1]);
   int anz_publ  = atol(argv[2]);
   int max_inst  = atol(argv[3]);
   
   puts("delete from PERSON;");
   puts("delete from INSTANZ;");   
   puts("delete from BUCH;");
   puts("delete from TECHREP;");
   puts("delete from ZEITSCHRIFT;");
   puts("delete from ZUGRIFFSRECHTE;");

   // Bibliothekar hinzufgen
   puts("insert into PERSON values (1,'','Bibliothekar','admin','555/10001000','555/20002000','puma@xmailer.cs.uni-bonn.de','R9999');");
   printf("insert into ZUGRIFFSRECHTE values ");
   printf("(1,'AUSLEIH'),");
   printf("(1,'AUSLEIHLISTE'),");
   printf("(1,'DETAIL'),");
   printf("(1,'RUECKGABE'),");
   printf("(1,'WEITERGABE'),");
   printf("(1,'SUCHEN'),");
   printf("(1,'PUBL_LOESCHEN'),");
   printf("(1,'PUBL_HINZUFUEGEN'),");
   printf("(1,'PUBL_AENDERN'),");
   printf("(1,'PERSON_LOESCHEN'),");
   printf("(1,'PERSON_HINZUFUEGEN'),");
   printf("(1,'PERSON_AENDERN'),");
   printf("(1,'RECHTE_AENDERN'),");
   printf("(1,'HISTORY_SEHEN'),");
   printf("(1,'HISTORY_LOESCHEN');\n");
        
   // Personen erzeugen
   for(int i = 0;i < anz_namen;i++) {
      printf("insert into PERSON values (");
      int a = random() % anz_vn;
      int b = random() % anz_nn;
      int v = random() % 1000;
      int t = random() % 10000000;
      int f = random() % 10000000;
      printf("%d,'%s','%s','geheim','%03d/%08d','%03d/%08d','test%04d@xmailer.bonn.edu','R%04d'",
             1000 + i,vn[a],nn[b],v,t,v,f,i,i+1);
      printf(");\n");         
       
      printf("insert into ZUGRIFFSRECHTE values ");
      printf("(%d,'AUSLEIH'),",1000+i);
      printf("(%d,'AUSLEIHLISTE'),",1000+i);
      printf("(%d,'DETAIL'),",1000+i);
      printf("(%d,'RUECKGABE'),",1000+i);
      printf("(%d,'WEITERGABE'),",1000+i);
      printf("(%d,'SUCHEN');",1000+i);
   }    
   
   // Publikationen erzeugen
   int num[3];
   num[0] = num[1] = num[2] = 1;
   int inv = 1;
   int sig = 1;
   for(int i = 0;i < anz_publ;i++) {
      int typ = random() % 3;
      int a = random() % anz_vn;
      int b = random() % anz_nn;
      int d = random() % anz_nn;
      int c = random() % anz_uni;
      switch(typ) {
         case 0:   // Buch einfgen
            printf("insert into BUCH values (");
            printf("'S-%05d','Buch #%d','%s %s',%d,'deutsch','ISBN-%04d-%04d','Auflage %d','%s-Verlag'",
               sig,num[0]++,vn[a],nn[b],1900+(random() % 110),random() % 10000,
               random() % 10000, random() % 20,nn[d]); 
            printf(");\n");              
          break;
         case 1:   // TechRep einfgen
            printf("insert into TECHREP values (");
            printf("'S-%05d','Report #%d','%s %s',%d,'deutsch','ISSN-%04d-%04d',%d,'Universitt %s'",
               sig,num[1]++,vn[a],nn[b],1900+(random() % 110),random() % 10000,
               random() % 10000, random() % 20,uni[c]); 
            printf(");\n");              
          break;
         case 2:   // Zeitschrift einfgen
            printf("insert into ZEITSCHRIFT values (");
            printf("'S-%05d','Zeitschrift #%d',%d,%d,'deutsch','%s-Verlag'",
               sig,num[2]++,1+(random() % 51),1900+(random() % 110),nn[d]); 
            printf(");\n");              
          break;          
      }
      int anzahl = random() % max_inst;
      for(int j = 0;j < anzahl;j++) {
         printf("insert into INSTANZ values (");
         printf("'I-%05d','S-%05d','VERFUEGBAR',0",inv++,sig);
         printf(");\n");
      }   
      sig++;
   }
   puts("optimize table PERSON;");
   puts("optimize table INSTANZ;");
   puts("optimize table BUCH;");
   puts("optimize table TECHREP;");
   puts("optimize table ZEITSCHRIFT;");
   puts("optimize table ZUGRIFFSRECHTE;");
}
