package puma.database;

import java.sql.SQLException;
import java.util.NoSuchElementException;
import java.io.SyncFailedException;
/*import Publikation;
import Liste; */

public class PublikationsInstanz extends Synchronisierbar {

  private Publikation quelle;
  private Liste instanzfelder;
  private Liste originalfelder;

  private static final String identifier = "INV_NR";

  public void neu(Publikation publikationsTyp)
  {
    instanzfelder.Neu();
    originalfelder.Neu();
    quelle = publikationsTyp;
  }

  public boolean geaendert() {
    if (quelle.geaendert() || (!instanzfelder.equals(originalfelder)))
      return true;
    return false;
  }

  public void synchronisieren(boolean force) throws SyncFailedException
  {
    quelle.synchronisieren(force);
    if (geaendert() || force) {
      try {
        String inventarNummer = originalfelder.Suchen(identifier).Inhalt();
        DatenbankKern.getInstance().InstanzAendern(inventarNummer,instanzfelder);
      } catch (DatenbankException e) {
        throw new SyncFailedException("Datenbank-Fehler");
      }
    }
  }

  public Liste inhalt() { return instanzfelder; }
  public Publikation zugehoerigePublikation() { return quelle; }
}
