// #######################################################################
// ### KernTest1.java                                                  ###
// ### Test des Datenbank-Kerns                                        ###
// ### Verantwortlich: Thomas Dreibholz, Dreibholz@bigfoot.com         ###
// #######################################################################


import java.io.*;
import java.sql.*;

import puma.database.DatenbankKern;
import puma.database.Liste;
import puma.database.StringDaten;
import puma.database.IntegerDaten;


// Test-Klasse
class KernTest1
{
   public static void main(String args[]) {
      try {
         // ****** Singleton-Pattern: Datenbank-Kern laden ***************
         System.out.println("Lade Kern...");
         Class.forName("DatenbankKern");
         System.out.println("Kern geladen!");
         DatenbankKern kern = DatenbankKern.getInstance();

         
         // ****** Tests **************************************************


         System.out.println("\n*** Publikation suchen ********************\n");
         Liste liste = new Liste();
         liste.Anfuegen(new StringDaten("TITEL","%Report%"));
         Liste x = kern.PublSuchen(liste);
         
         System.out.println("*** Ergebnis ********************************");
         x.Ausgabe();


         System.out.println("\n*** Publiaktion ndern *********************\n");
         Liste n1 = new Liste();
         n1.Anfuegen(new StringDaten("TYP","BUCH"));
         n1.Anfuegen(new StringDaten("SIGNATUR","Sig001"));
         n1.Anfuegen(new StringDaten("TITEL","Mein Buch"));
         n1.Anfuegen(new StringDaten("AUTOREN","Autor #1, A2"));
         n1.Anfuegen(new IntegerDaten("JAHR",1500));
         n1.Anfuegen(new StringDaten("SPRACHE","deutsch"));
         n1.Anfuegen(new StringDaten("ISBN","1-555-2"));
         n1.Anfuegen(new StringDaten("AUFLAGE","A1"));
         n1.Anfuegen(new StringDaten("VERLAG","XY-Verlag, Bonn"));
         kern.PublAendern("Sig001",n1);
         
         
         System.out.println("\n*** Publikation lschen ********************\n");
         kern.PublLoeschen("Sig002");
         
         
         // ***************************************************************         
      } catch(Exception e) {
         System.err.println("FEHLER: " + e);
      }
   }  
}