// #######################################################################
// ### KernTest4.java                                                  ###
// ### Test des Datenbank-Kerns                                        ###
// ### Verantwortlich: Thomas Dreibholz, Dreibholz@bigfoot.com         ###
// #######################################################################


import java.io.*;
import java.sql.*;

import puma.database.DatenbankKern;
import puma.database.Liste;
import puma.database.StringDaten;
import puma.database.IntegerDaten;


// Test-Klasse
class KernTest4
{
   public static void main(String args[]) {
      try {
         // ****** Singleton-Pattern: Datenbank-Kern laden ***************
         System.out.println("Lade Kern...");
         Class.forName("DatenbankKern");
         System.out.println("Kern geladen!");
         DatenbankKern kern = DatenbankKern.getInstance();

         
         // ****** Tests **************************************************


         System.out.println("\n*** History hinzufgen ********************\n");        
         Liste h = new Liste();
         h.Anfuegen(new StringDaten("INV_NR","Inv0001"));
         h.Anfuegen(new StringDaten("STATUS","AUSGELIEHEM"));        
         h.Anfuegen(new IntegerDaten("PERSON_ID",1000));   
         h.Anfuegen(new StringDaten("ZEITPUNKT","$NOW()"));
         kern.HistoryHinzufuegen(h);     
         
         System.out.println("\n*** History suchen ************************\n");
         Liste h2 = kern.HistorySuchen("Inv0001");
         System.out.println("*** Ergebnis ********************************");         
         h2.Ausgabe();

         
         // ***************************************************************         
      } catch(Exception e) {
         System.err.println("FEHLER: " + e);
      }
   }  
}