// #######################################################################
// ### KernTest5.java                                                  ###
// ### Test des Datenbank-Kerns                                        ###
// ### Verantwortlich: Thomas Dreibholz, Dreibholz@bigfoot.com         ###
// #######################################################################


import java.io.*;
import java.sql.*;

import puma.database.DatenbankKern;
import puma.database.Liste;
import puma.database.StringDaten;
import puma.database.IntegerDaten;


// Test-Klasse
class KernTest5
{
   public static void main(String args[]) {
      try {
         // ****** Singleton-Pattern: Datenbank-Kern laden ***************
         System.out.println("Lade Kern...");
         Class.forName("DatenbankKern");
         System.out.println("Kern geladen!");
         DatenbankKern kern = DatenbankKern.getInstance();
         
         // ****** Tests **************************************************

         System.out.println("\n*** Status-Typen ****************************\n");
         kern.HoleStatusTypen().Ausgabe();

         System.out.println("\n*** Publikations-Typen **********************\n");
         StringListeDaten publTypen = kern.HolePublTypen();
         publTypen.Ausgabe();
         for(int typ = 0;typ < publTypen.Anzahl();typ++) {
            Liste l = kern.HolePublFelder(publTypen.Element(typ));
            System.out.println("\n###### Felder des Publikationstyps " + publTypen.Element(typ) + " ######\n");
            l.Ausgabe();
         }

         System.out.println("\n*** Masken-Typen ***************************\n");
         StringListeDaten maskenTypen = kern.HoleMaskenTypen();
         maskenTypen.Ausgabe();
         System.out.println("");
         for(int maske = 0;maske < maskenTypen.Anzahl();maske++) {
            for(int typ = 0;typ < publTypen.Anzahl();typ++) {
               StringListeDaten l = kern.HoleMaskenFelder(maskenTypen.Element(maske),publTypen.Element(typ));
               l.Ausgabe();               
            }
          }

         System.out.println("\n*** History-Felder ****************\n");
         kern.HoleHistoryFelder().Ausgabe();
         
         System.out.println("\n*** Standard-Zugriffsrechte ****************\n");
         kern.HoleStandardZGR().Ausgabe();
         
         System.out.println("\n*** Instanz-Felder *************************\n");
         kern.HoleInstanzFelder().Ausgabe();
         
         System.out.println("\n*** Person-Felder **************************\n");
         kern.HolePersonFelder().Ausgabe();
                  
         System.out.println("\n*** Standard-Zugriffsrechte ****************\n");
         kern.HoleStandardZGR().Ausgabe();

         System.out.println("\n*** Zugriffsrechte fr Benutzer ID=1000 ****\n");
         kern.HoleZGR(1000).Ausgabe();
         
         // ***************************************************************
         
      } catch(Exception e) {
         System.err.println("ERROR: " + e);
      }
   }  
}