package puma.control;

/** Abstrakte Oberklasse aller Commands.
 *  @author Sven Mller
 */
public abstract class Command {
   /** Rckverweis auf die laufende Server-Instanz.
    */
   protected ServerApplication serverApp;
   
   /** StandardKonstruktor.
    * @param serverApp  Ein Rckverweis auf die aufrufende Server-Instanz.
    */
   
   public Command(ServerApplication serverApp) {
      this.serverApp = serverApp;
   }
      
   /** Methode, die Ausfhrung des Commands definiert.
    * @param in Objekt, das Input-Daten liefert.
    * @param out Objekt, das fr die Darstellung der Output-Daten sorgt.
    */  
   abstract public void execute(InType in, OutType out);
}
