package puma.control;

/** Command, das Suche nach Instanzen umsetzt.
 *  @author Sven Mller
 */
public class I_SuchenCmd extends Command {
   
   /** Standard-Konstruktor.
    * @param serverApp  Ein Rckverweis auf die aufrufende Server-Instanz.
    */         
   public I_SuchenCmd(ServerApplication serverApp) {
      super(serverApp);
   }      
   
     
  /** Fhrt die dem Command zugeordnete Aktion aus.
    *  
    * Es wird ein neues Objekt vom Typ I_Suchen erzeugt. Diesem wird im
    * Konstruktor eine Publikation-signatur vom Typ String bergeben,
    * die mittels <i>in</i> gewonnen wird.
    * Mit <i>out</i> wird das Ergebnis in das Ausgabeformat gebracht.
    *
    * @see I_Suchen
    * @param in Objekt, das Input-Daten liefert.
    * @param out Objekt, das fr die Darstellung der Output-Daten sorgt.
    */      
   public void execute(InType in, OutType out) {
      try {
         I_Suchen searchObj = new I_Suchen(in.getSignatur() );
         out.setInstanzArray(
             searchObj.deliverResult() );
      } catch (Exception e) { out.createErrorMsg(e); }
   }   

}
