// #######################################################################
// ### StringDaten.java                                                ###
// ### Verwaltung von String-Datenobjekten                             ###
// ### Verantwortlich: Thomas Dreibholz, Dreibholz@bigfoot.com         ###
// #######################################################################


package puma.database;


import java.io.*;
import java.util.*;


// ****** StringDaten ****************************************************
public class StringDaten implements Datenobjekt
{
   private String beschreibung;
   private String daten;


   // ###### Konstruktor #################################################   
   public StringDaten(String nBeschreibung, String nDaten) {
      beschreibung = nBeschreibung;
      daten        = nDaten;   
   }

   
   // ###### Vergleich mit anderem StringDaten-Objekt ####################
   public boolean equals(StringDaten vergleich) {
      return( beschreibung.equals(vergleich.beschreibung) &&
              daten.equals(vergleich.daten) );
   }

   
   // ###### Eingabetyp als String zurckgeben ###########################
   public String EingabeTyp() {
      return("STRING");
   }

   
   // ###### Beschreibung zurckgeben ####################################
   public String Beschreibung() {
      return(beschreibung);
   }


   // ###### Inhalt zurckgeben ##########################################
   public String Inhalt() {
      return(daten);
   }


   // ###### Inhalt zurckgeben ##########################################
   public int InhaltInteger() {
      return((new Integer(daten)).intValue());
   }


   // ###### Inhalt ndern ###############################################
   public void Aendern(String neu) {
      daten = neu;
   }


   // ###### Inhalt ndern ###############################################
   public void AendernInteger(int neu) {
      daten = new String("" + neu);
   }

   
   // ###### Ausgabe #####################################################
   public void Ausgabe() {
      System.out.println(toString());
   }


   // ###### Umwandlung in String ########################################
   public String toString() {
      return(beschreibung + " = " + daten);
   }
}
