// #######################################################################
// ### KernTest6.java                                                  ###
// ### Test des Datenbank-Kerns                                        ###
// ### Verantwortlich: Thomas Dreibholz, Dreibholz@bigfoot.com         ###
// #######################################################################


import java.io.*;
import java.sql.*;

import puma.database.DatenbankKern;
import puma.database.Liste;
import puma.database.StringDaten;
import puma.database.StringListeDaten;
import puma.database.IntegerDaten;


// Test-Klasse
class KernTest6
{
   public static void main(String args[]) {
      try {
         // ****** Singleton-Pattern: Datenbank-Kern laden ***************
         System.out.println("Lade Kern...");
         Class.forName("DatenbankKern");
         System.out.println("Kern geladen!");
         DatenbankKern kern = DatenbankKern.getInstance();

         
         // ****** Tests **************************************************


         System.out.println("\n*** Publikation suchen ********************\n");
         Liste liste = new Liste();
         liste.Anfuegen(new StringDaten("UNI","Universitt Irkutsk"));         
      //   liste.Anfuegen(new StringDaten("TITEL","Atom%"));
         Liste x = kern.PublSuchen(liste);
         
         System.out.println("*** Ergebnis ********************************");
         x.Ausgabe();

         System.out.println("\n*** Publikation suchen ********************\n");
         Liste liste2 = new Liste();
         StringListeDaten ausschluss = new StringListeDaten("AUSSCHLUSS");
         liste2.Anfuegen(new StringDaten("UNI","Universitt Irkutsk"));         
      //   liste2.Anfuegen(new StringDaten("TITEL","Atom%"));
         ausschluss.Anfuegen("TECHREP");      
         Liste y = kern.PublSuchenNeu(liste2,ausschluss);
         
         System.out.println("*** Ergebnis ********************************");
         y.Ausgabe();
         System.out.println("Diese Liste mu *leer* sein!!!");
         
         // ***************************************************************         
      } catch(Exception e) {
         System.err.println("FEHLER: " + e);
      }
   }  
}